<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\DF\Modules\Entrada\Services\EntradasOperadorLogisticoService;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
    
class EntradasOperadorLogisticoController extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = '';
	protected $parameterBagColumns = array('');
    protected $entradasOperadorLogisticoService;

    public function __construct($crudService, $parameterBag, EntradasOperadorLogisticoService $service) {
        parent::__construct($crudService, $parameterBag);
        $this->EntradasOperadorLogisticoService = $service;
    }   
    
    public function gerarEntrada(DTO\Request\Row $request, DTO\Response $response) {
        $notas          = $request->getRow(); 
        $cdFiliOperLog  = $notas[0]['CDFILIAL'];
        $cdFilDest      = $notas[0]['CDFILDEST'];
        $cdTipoOper     = isset($notas[0]['CDTIPOOPER']) ? $notas[0]['CDTIPOOPER'] : '';
        $dtEntrada      = (isset($notas[0]['DTENTRADA'])) ? $notas[0]['DTENTRADA'] : date("d/m/Y");
        
        $this->EntradasOperadorLogisticoService->gerarEntrada($cdFiliOperLog, $cdFilDest, $cdTipoOper, $dtEntrada, $notas);
        
        $erros = $this->EntradasOperadorLogisticoService->getErros();
        $numNotasSucesso = $this->EntradasOperadorLogisticoService->getQtNotasSucesso();
        $response->addDataset(new DataSource\DataSet('errosGeracao', $erros));
        if($numNotasSucesso != 0) {
            $response->addMessage(new Response\Message("A entrada de $numNotasSucesso notas fiscais foram feitas com sucesso."));
        }
        else {
            $response->addMessage(new Response\Message("Não foi possível realizar a entrada das notas selecionadas."));
        }
    }

}
