<?php

namespace Teknisa\DF\Modules\Entrada\Services;

use Geral\Entities\Paramgeral;

class Dfe52000RelacionamentoProdutoXProduto {
    protected $Dfe52000Factory;
    protected $Nrorg;

    public function __construct($Dfe52000RelacionamentoProdutoXProduto, $environment) {
        $this->Dfe52000Factory = $Dfe52000RelacionamentoProdutoXProduto;
        $this->Nrorg = $environment->getNrOrg();
    }

    public function checaProdutoXMLExistente($cdprodutoxml, $cdforneced, $cdproduto, $cdfilial, $dataSourceName) {
        try {
            $produto = $this->Dfe52000Factory->checaProdutoXMLExistente($cdprodutoxml, $cdforneced, $cdproduto, $cdfilial, $dataSourceName);
            if(!empty($produto)){
                $paramgeral = Paramgeral::findOneByNrorg($this->Nrorg);
                $cdpictprod  = $paramgeral->getCdpictprod();
                $produtoMaksAply = $this->maskAply($produto[0]['CDARVPROD'], $cdpictprod);
                $message = $produto[0]['NMPRODUTO'] . " já foi adicionado ao Produto XML " . $cdprodutoxml . ".";
                throw new \Exception($message, 1);
    	    }
        } catch (\Exception $e) {
            throw $e;
        }
	}

    public function editRow($oldCdprodutoxml, $oldCdproduto, $cdforneced, $cdproduto, $nrorg, $newCdprodutoxml, $nmprodutoxml, $fatconvol, $cdfilial, $dataSourceName) {
        try {
            $this->Dfe52000Factory->editRow($oldCdprodutoxml, $oldCdproduto, $cdforneced, $cdproduto, $nrorg, $newCdprodutoxml, $nmprodutoxml, $fatconvol, $cdfilial, $dataSourceName);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function maskAply($produto, $mascara){
        $j = 0;
        $newProduto = "";
        for ($i=0; $i < strlen($mascara); $i++) {
            if(substr($mascara, $i, 1) !== "."){
                $newProduto .= substr($produto, $j, 1);
                $j++;
            } else {
                $newProduto .= ".";
            }
        }
        return $newProduto;
    }
    
    public function getFranqueadora() {
        return $this->Dfe52000Factory->getFranqueadora();
    }
    
    public function getAllFornecedor($nmrazsocforn) {
        return $this->Dfe52000Factory->getAllFornecedor($nmrazsocforn);
    }
    
}